diff --git a/doc/device-tree-bindings/reboot-mode/reboot-mode-rtc.txt b/doc/device-tree-bindings/reboot-mode/reboot-mode-rtc.txt
new file mode 100644
index 0000000000..23aa12c88c
--- /dev/null
+++ b/doc/device-tree-bindings/reboot-mode/reboot-mode-rtc.txt
@@ -0,0 +1,22 @@
+RTC Reboot Mode Configuration
+
+Required Properties:
+- compatible: must be "reboot-mode-rtc".
+- rtc: reference to the rtc device used.
+- reg: start register and the number of bytes used. Maximum 4 bytes supported.
+- modes: list of properties that define the modes and associated unique ids.
+
+Optional Properties:
+- u-boot,env-variable: used to save the reboot mode (default: reboot-mode).
+- big-endian: if the magic value is stored in big-endian. (default: false).
+
+Example:
+	reboot-mode-rtc {
+		compatible = "reboot-mode-rtc";
+		rtc = <&rtc_0>;
+		reg = <0x14 4>;
+		u-boot,env-variable = "bootstatus";
+		big-endian;
+		modes-test = <0x21969147>;
+		modes-download = <0x51939147>;
+	};
diff --git a/drivers/reboot-mode/Kconfig b/drivers/reboot-mode/Kconfig
index ff65e2031a..ac67bfcef6 100644
--- a/drivers/reboot-mode/Kconfig
+++ b/drivers/reboot-mode/Kconfig
@@ -24,4 +24,13 @@ config DM_REBOOT_MODE_GPIO
 		a device in a specific mode by using a GPIO that can be controlled
 		outside U-Boot.
 
+config DM_REBOOT_MODE_RTC
+	bool "Use RTC as reboot mode backend"
+	depends on DM_REBOOT_MODE
+	default n
+	help
+		Use RTC non volatile memory to control the reboot mode. This will allow users to boot
+		a device in a specific mode by using a register(s) that can be controlled
+		outside U-Boot (e.g. Kernel).
+
 endmenu
diff --git a/drivers/reboot-mode/Makefile b/drivers/reboot-mode/Makefile
index 04917be4f4..2c13780ced 100644
--- a/drivers/reboot-mode/Makefile
+++ b/drivers/reboot-mode/Makefile
@@ -6,3 +6,4 @@
 
 obj-$(CONFIG_DM_REBOOT_MODE) += reboot-mode-uclass.o
 obj-$(CONFIG_DM_REBOOT_MODE_GPIO) += reboot-mode-gpio.o
+obj-$(CONFIG_DM_REBOOT_MODE_RTC) += reboot-mode-rtc.o
diff --git a/drivers/reboot-mode/reboot-mode-rtc.c b/drivers/reboot-mode/reboot-mode-rtc.c
new file mode 100644
index 0000000000..db11acc75a
--- /dev/null
+++ b/drivers/reboot-mode/reboot-mode-rtc.c
@@ -0,0 +1,132 @@
+// SPDX-License-Identifier: GPL-2.0+
+/*
+ * Copyright (c), Vaisala Oyj
+ */
+
+#include <common.h>
+#include <rtc.h>
+#include <dm.h>
+#include <errno.h>
+#include <reboot-mode/reboot-mode-rtc.h>
+#include <reboot-mode/reboot-mode.h>
+
+DECLARE_GLOBAL_DATA_PTR;
+
+static int reboot_mode_get(struct udevice *dev, u32 *buf)
+{
+	if (!buf)
+		return -EINVAL;
+
+	int ret;
+	u8 *val = (u8 *)buf;
+	struct reboot_mode_rtc_platdata *plat_data;
+
+	plat_data = dev_get_platdata(dev);
+	if (!plat_data)
+		return -EINVAL;
+
+	for (int i = 0; i < plat_data->size; i++) {
+		ret = rtc_read8(plat_data->rtc, plat_data->addr + i);
+		if (ret < 0)
+			return ret;
+
+		val[i] = ret;
+	}
+
+	if (plat_data->is_big_endian)
+		*buf = __be32_to_cpu(*buf);
+	else
+		*buf = __le32_to_cpu(*buf);
+
+	return 0;
+}
+
+static int reboot_mode_set(struct udevice *dev, u32 buf)
+{
+	int ret;
+	u8 *val;
+	struct reboot_mode_rtc_platdata *plat_data;
+
+	plat_data = dev_get_platdata(dev);
+	if (!plat_data)
+		return -EINVAL;
+
+	if (plat_data->is_big_endian)
+		buf = __cpu_to_be32(buf);
+	else
+		buf = __cpu_to_le32(buf);
+
+	val = (u8 *)&buf;
+
+	for (int i = 0; i < plat_data->size; i++) {
+		ret = rtc_write8(plat_data->rtc, (plat_data->addr + i), val[i]);
+		if (ret < 0)
+			return ret;
+	}
+
+	return 0;
+}
+
+#if CONFIG_IS_ENABLED(OF_CONTROL)
+static int reboot_mode_ofdata_to_platdata(struct udevice *dev)
+{
+	struct ofnode_phandle_args phandle_args;
+	struct reboot_mode_rtc_platdata *plat_data;
+
+	plat_data = dev_get_platdata(dev);
+	if (!plat_data)
+		return -EINVAL;
+
+	if (dev_read_phandle_with_args(dev, "rtc", NULL, 0, 0, &phandle_args)) {
+		dev_err(dev, "RTC device not specified\n");
+		return -ENOENT;
+	}
+
+	if (uclass_get_device_by_ofnode(UCLASS_RTC,
+					phandle_args.node, &plat_data->rtc)) {
+		dev_err(dev, "could not get the RTC device\n");
+		return -ENODEV;
+	}
+
+	plat_data->addr = fdtdec_get_addr_size_auto_noparent(gd->fdt_blob,
+							     dev_of_offset(dev),
+							     "reg",
+							     0,
+							     (fdt_size_t *)&plat_data->size,
+							     false);
+	if (plat_data->addr == FDT_ADDR_T_NONE) {
+		dev_err(dev, "Invalid RTC address\n");
+		return -EINVAL;
+	}
+
+	if (plat_data->size > sizeof(u32)) {
+		dev_err(dev, "Invalid reg size\n");
+		return -EINVAL;
+	}
+
+	plat_data->is_big_endian = ofnode_read_bool(dev->node, "big-endian");
+
+	return 0;
+}
+
+static const struct udevice_id reboot_mode_ids[] = {
+	{ .compatible = "reboot-mode-rtc", 0 },
+	{ }
+};
+#endif
+
+static const struct reboot_mode_ops reboot_mode_rtc_ops = {
+	.get = reboot_mode_get,
+	.set = reboot_mode_set,
+};
+
+U_BOOT_DRIVER(reboot_mode_rtc) = {
+	.name = "reboot-mode-rtc",
+	.id = UCLASS_REBOOT_MODE,
+#if CONFIG_IS_ENABLED(OF_CONTROL)
+	.of_match = reboot_mode_ids,
+	.ofdata_to_platdata = reboot_mode_ofdata_to_platdata,
+#endif
+	.platdata_auto_alloc_size = sizeof(struct reboot_mode_rtc_platdata),
+	.ops = &reboot_mode_rtc_ops,
+};
diff --git a/include/reboot-mode/reboot-mode-rtc.h b/include/reboot-mode/reboot-mode-rtc.h
new file mode 100644
index 0000000000..3613678f63
--- /dev/null
+++ b/include/reboot-mode/reboot-mode-rtc.h
@@ -0,0 +1,16 @@
+/* SPDX-License-Identifier: GPL-2.0+ */
+/*
+ * Copyright (c), Vaisala Oyj
+ */
+
+#ifndef REBOOT_MODE_REBOOT_MODE_RTC_H_
+#define REBOOT_MODE_REBOOT_MODE_RTC_H_
+
+struct reboot_mode_rtc_platdata {
+	struct udevice *rtc;
+	bool is_big_endian;
+	int addr;
+	size_t size;
+};
+
+#endif /* REBOOT_MODE_REBOOT_MODE_RTC_H_ */